#include "myheader.h"

int n, log2n;

int bitsum(int i){int sum = 0; while (i>0){sum += (i & 1); i >>= 1;} return sum;}

bool sortdirection(int i){return (bitsum(i>>1) & 1);}

int clsh(int i){int mask = 1 << (log2n-1);
  return (i & mask) ? ((i ^ mask) << 1) + 1  :   i << 1;}

struct Buffer{
  int idx;
  int value;
  bool sd;
}; 

void exchange(int a[], bool sd[], int locals){
  Buffer inbuf; Buffer outbuf; int neighbor; int i, j;
  int* b = new int[locals]; 
  bool* bsd = new bool[locals];
  for (i=0; i<locals; i++){ 
    outbuf.idx = clsh(MyProcId*locals+i); /* send one message */
    neighbor = outbuf.idx/locals;
    if (neighbor != MyProcId){
      outbuf.value = a[i];
      outbuf.sd = sd[i];
      send(neighbor,&outbuf,1);} 
    else{ b[outbuf.idx%locals] = a[i]; bsd[outbuf.idx%locals] = sd[i];}
    for (j=0; j<p; j++) /* process incoming messages */
      if ((j != MyProcId) && (clsh(j*locals+i)/locals == MyProcId)){
        receive(j,&inbuf,1);
        b[inbuf.idx%locals] = inbuf.value;
        bsd[inbuf.idx%locals] = inbuf.sd;}}
   for (i=0; i<locals; i++){
     a[i] = b[i]; sd[i] = bsd[i];}
   delete[] b; delete[] bsd;}

void sort(int a[], bool sd[], int locals){ 
 int aux;
 for (int i=0; i<locals; i+=2){ /* sort */
   if ((!sd[i] && (a[i] > a[i+1])) || (sd[i] && (a[i] < a[i+1]))){
     aux = a[i]; a[i]=a[i+1]; a[i+1]=aux;}
     sd[i+1] = sd[i];}}
 
int main(int argc, char * argv[]){
  init(argc,argv);
  n = Problemsize;
  log2n = (int) (log(n)/log(2)+0.1);
  int locals = n/p;         
  int blocksize = locals / 2;
  int i, l, j;
  int* a = new int[locals];
  bool* sd= new bool[locals];

  /* init arrays */
  for (i=0; i<locals; i++){  
    a[i] = ((MyProcId*locals+i) * 40573) % 97;
    sd[i] = sortdirection(MyProcId*locals+i);}
  show(a,locals);

  sort(a,sd,locals); 
  for (l=1; l<log2n; l++){
    for (j=0; j<log2n-l-1; j++){ /* no sorting, just pass on elements */
      exchange(a,sd,locals);
      if (Debug) show(a,locals);}
    for (j=log2n-l-1; j<log2n; j++){ /* exchange and sort*/
      exchange(a,sd,locals);        
      sort(a,sd,locals);
      if (Debug) show(a,locals);}}
       
  /* print the result */
  show(a,locals);
  delete[] a; delete[] sd;
  finish();
}
