#include "myheader.h"

int m,n ;
ProcessorNo left_, right_, up, down;
int MyX,MyY; 
int sqrtp;

int min(int x, int y){ return ((x < y) ? x : y);}

void matmult(int* A[], int* B[], int* C[]){
  int k, r, l;
  /* initialize  C */
  for (k=0;k<m;k++) 
    for (l=0;l<m;l++) {
      C[k][l] = 99999;}
  /* horizontal rotation of A and vertical rotation of B*/
  communicateMat<int>((MyX + sqrtp - MyY) % sqrtp + MyY * sqrtp,  (MyX + MyY) % sqrtp + MyY * sqrtp, A, m,m);
  communicateMat<int>((MyProcId+p - MyX*sqrtp) % p, (MyProcId+MyX*sqrtp) % p, B, m,m); 
  /* interleaved local multiplication & communication */
  for (r=0; r<sqrtp; r++){
    for (k=0;k<m;k++) 
      for (l=0;l<m;l++) 
        for (int q=0;q<m;q++) 
          C[k][l] =  min(C[k][l], A[k][q] + B[q][l]);
    communicateMat<int>(left_, right_, A, m,m);
    communicateMat<int>(up, down, B, m,m);}}  
 
int main (int argc, char * argv[]) {
  init(argc,argv); 
  int k,l,q;
  n = Problemsize;
  sqrtp = (int) sqrt(p+0.1);
  MyX = MyProcId % sqrtp;
  MyY = MyProcId / sqrtp;
  MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);
  m = n/sqrtp;
  int** A = new int*[m];
  int** B = new int*[m];
  int** C = new int*[m];
   for (k=0; k<m; k++){
    A[k] = new int[m];
    B[k] = new int[m];
    C[k] = new int[m];}

  int** aux;
  int log2n = (int) (log(n)/log(2)+0.1);
 
  left_  = (MyX + sqrtp - 1) % sqrtp + MyY * sqrtp;
  right_ = (MyX + 1) % sqrtp + MyY * sqrtp;
  up    = (MyProcId+p - sqrtp) % p;
  down  = (MyProcId+sqrtp) % p;

  /* initialize A */
  for (k=0;k<m;k++) 
    for (l=0;l<m;l++) 
      A[k][l] = abs(MyY*m+k-(MyX*m+l)) <= 1 ? abs(MyY*m+k-(MyX*m+l)) : 99;
  showMatrix<int>(A,sqrtp,sqrtp,m,m);

  for (q=0; q<log2n; q++){
    /* copy A to B */
    for (int k=0;k<m;k++) 
      for (int l=0;l<m;l++) 
        B[k][l] = A[k][l];
    matmult(A,B,C);
    aux = A; A = C; C = aux;}
  showMatrix<int>(A,sqrtp,sqrtp,m,m);
  for (k=0; k<m; k++){
    delete[] A[k];  delete[] B[k]; delete[] C[k];}
  delete[] A;  delete[] B; delete[] C; 
  finish();
}
    
