#include "myheader.h"

int m, n;
ProcessorNo left_, right_, up, down;
int k,l,r,q; int MyX,MyY;
   
int main (int argc, char * argv[]){
  init(argc,argv);
  n = Problemsize;

  int sqrtp = (int) sqrt(p+0.1);
  MyX = MyProcId % sqrtp;
  MyY = MyProcId / sqrtp;
  MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);
  m = n/sqrtp;
  int** A = new int*[m];
  int** B = new int*[m];
  int** C = new int*[m];
  for (k=0; k<m; k++){
    A[k] = new int[m];
    B[k] = new int[m];
    C[k] = new int[m];}

  left_  = (MyX + sqrtp - 1) % sqrtp + MyY * sqrtp;
  right_ = (MyX + 1) % sqrtp + MyY * sqrtp;
  up    = (MyProcId+p - sqrtp) % p;
  down  = (MyProcId+sqrtp) % p;

  /* init. A,B, and C */
  for (k=0;k<m;k++) 
    for (l=0;l<m;l++) {
      A[k][l] = k+l+(MyX+MyY)*m; B[k][l] = A[k][l]; C[k][l] = 0;}

#if OUTPUT == 1      
  if (MyProcId == 0)cout <<"A:" << endl << flush;
  showMatrix<int>(A,sqrtp,sqrtp,m,m); 
  if (MyProcId == 0)cout <<"B:" << endl << flush;
  showMatrix<int>(B,sqrtp,sqrtp,m,m);
#endif

  /* Gentleman's algorithm: */
  /* 1. horizontal rotation of A and vertical rotation of B */
  communicateMat<int>((MyX + sqrtp - MyY) % sqrtp + MyY * sqrtp,  (MyX + MyY) % sqrtp + MyY * sqrtp, A, m,m);
  communicateMat<int>((MyProcId+p - MyX*sqrtp) % p, (MyProcId+MyX*sqrtp) % p, B, m,m); 

  /* 2. interleaved local multiplication & communication */
  for (r=0; r<sqrtp; r++) {
    for (k=0;k<m;k++) 
      for (l=0;l<m;l++) 
        for (q=0;q<m;q++) 
          C[k][l] +=  A[k][q] * B[q][l];
    communicateMat<int>(left_, right_, A, m,m);
    communicateMat<int>(up,down, B, m,m);}

  /* print result and terminate */
#if OUTPUT == 1  
  if (MyProcId == 0)cout <<"A x B:" << endl << flush;
  showMatrix<int>(C,sqrtp,sqrtp,m,m);  
#endif
  
  for (k=0; k<m; k++){
    delete[] A[k];  delete[] B[k]; delete[] C[k];}
  delete[] A; delete[] B; delete[] C; 
  finish(); 
}
    
