#include "myheader.h"

typedef int C;
int m, n;  

int randomval(){int r= rand(); srand(r+MyProcId); return rand() % 1000000;}

void initIndex(C a[], C selection[], int idx[]){ 
  idx[0] = 0; 
  int j = 0;  int k = 0;
  while ((k<=m) && (j<p-1))
    if (a[k] >= selection[j]) idx[++j] = k*sizeof(C);
    else k++; 
  for (k= j+1; k<= p; k++) idx[k] = m*sizeof(C);} 

void initIndex2(C b[], int first, int last, int idx[]){
  int jm;
  idx[0] = 0; 
  for (int j=0; j<p; j++){
    jm = j*m;
    if ((jm+m <= first) || (jm >= last)) idx[j+1] = idx[j];
    else if ((jm < first) && (jm+m > first) && (jm < last)) idx[j+1] = idx[j]+(jm+m-first)*sizeof(C);
    else if (jm+m >= last) idx[j+1] = (last-first)*sizeof(C);
	 else idx[j+1] = idx[j] + m*sizeof(C);}}

void takeSample(C a[], C sample[]){
  for (int i=0; i<m; i++) sample[i] = a[i*n/(p*p)];}

void quicksort(int low, int high, C a[]) {
    if (low >= high) return;
    int left = low;  int right = high;
    int pivot = a[(low+high)/2];
    do { while (a[left] < pivot) left++;
         while(a[right] > pivot) right--;
         if (left <= right){
           int temp = a[right];
           a[right--] = a[left];
           a[left++] = temp;}}
    while (left <= right);
    if (low < right) quicksort(low,right,a);
    if (high > left) quicksort(left,high,a);}

void wait(int k){for(int i=0; i<k; i++);}

void samplesort(C a[]){ 
  C* sample = new C[p]; 
  C* allsamples = new C[p*p];
  C* selection = new C[p-1]; 
  int* idx = new int[p+1];
  int* inidx = new int[p+1];  
  int* counters = new int[p]; 
  int* incounters = new int[p];
  int upperbound = 2*n/p; /* could be refined */
  C* b = new C[upperbound];  
  int first, i;

  /* sort local partition */
  quicksort(0,m-1,a);
  if (Debug) show(a,m);

  /* take samples of each partition, collect them on processor 0 */
  takeSample(a,sample);
  if (Debug) show(sample,p);
  MPI_Gather(sample,sizeof(C)*p,MPI_BYTE,
             allsamples,sizeof(C)*p,MPI_BYTE,0,MPI_COMM_WORLD);
  if (Debug) show(allsamples,p*p);

  /* sort collected samples and select boundary values for each processor */
  if (MyProcId == 0){
    quicksort(0,p*p-1,allsamples);
    for (i=0; i<p-1; i++)
      selection[i] = allsamples[(i+1)*p + p/2-1];} 
  if (Debug) show(allsamples,p*p); 
  if (Debug) show(selection,p-1);

  /* broadcast the boundary values to all processors */
  MPI_Bcast(selection,(p-1)*sizeof(C),MPI_BYTE,0,MPI_COMM_WORLD);
  if (Debug) show(selection,p-1);

  /* each processor sends its values to the destinations according to the boundary values */
  initIndex(a,selection,idx); 
  if (Debug) show(idx,p+1); 
  for (i=0; i<p; i++) counters[i] = idx[i+1]-idx[i]; 
  if (Debug) show(counters,p);   

  MPI_Alltoall(counters,1,MPI_INT,incounters,1,MPI_INT,MPI_COMM_WORLD); 
  if (Debug) show(incounters,p);
  inidx[0] = 0;
  for (i=0; i<p; i++) inidx[i+1] = inidx[i] + incounters[i];
  if (Debug) show(inidx,p+1);
  if (Debug)  for (i=0; i<upperbound; i++) b[i] = 0;
  MPI_Alltoallv(a,counters,idx,MPI_BYTE,
                b,incounters,inidx,MPI_BYTE,MPI_COMM_WORLD);
  if (Debug) show(b,upperbound);

  /* each processor locally sorts the received values */
  int received = inidx[p]/sizeof(C);
  quicksort(0,received-1,b);
  if (Debug) show(b,upperbound);

  /* rearrange the sorted result such that every processor gets the same number of values */
  MPI_Scan(&received,&first,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
  first -= received;
  initIndex2(b,first,first+received,idx);
  if (Debug) show(idx,p+1); 
  for (i=0; i<p; i++) counters[i] = idx[i+1]-idx[i];
  if (Debug) show(counters,p);
  MPI_Alltoall(counters,1,MPI_INT,incounters,1,MPI_INT,MPI_COMM_WORLD); 
  if (Debug) show(incounters,p);
  inidx[0] = 0;
  for (i=0; i<p; i++) inidx[i+1] = inidx[i] + incounters[i];
  if (Debug) show(inidx,p+1);
  MPI_Alltoallv(b,counters,idx,MPI_BYTE,
                a,incounters,inidx,MPI_BYTE,MPI_COMM_WORLD); 
  if (Debug) show(a,m);  
//   delete[] sample; delete[] allsamples; 
//   delete[] selection; delete[] idx; delete[] inidx;
//   delete[] counters; delete[] incounters; delete[] b;
  }

int main(int argc, char **argv){
  init(argc,argv);
  n = Problemsize;
  m = n/p;
  C* a = new C[m];
  for (int i=0; i<m; i++) a[i] = randomval();
  show(a,m);
  samplesort(a);
  show(a,m);  
//  delete[] a;
  finish();                 
}
