#include "Skeleton.h"

int add(const int a, const int b){return a+b;}

int inc(const int a){return a+1;}

int sum(const int a, const int b, const int c){return a+b+c;}

int sum4(const int a, const int b, const int c, const int d){return a+b+c+d;}

int times(const int a, const int b){return a*b;}

int one(const int a, const int b){return 1;}

int id(int a){return a;}

//int xor(int a, int b){return (a^b);}

int xor1(int a, int b){return a^1;}

int xor2(int a, int b){return b^1;}

int main(int argc, char **argv){
//*************************************************************
// Test: test of data parallel matrix skeletons
// *************************************************************
  try{
    InitSkeletons(argc,argv);

    DistributedMatrix<int> A(6,4,& add,2,2);
    if (sk_myid == 0) cout << "A: "; A.show(); 
    int result = A.fold(& add);
    if (sk_myid == 0)  cout << "A.fold(): " << result << endl;
    DistributedMatrix<int> B  = A.map(curry(add)(result-95));
    DistributedMatrix<int> C =  A.zipWith(B,times);  
    if (sk_myid == 0) cout << "C: " << endl; C.show();
    C.permutePartition(xor1, xor2);
    if (sk_myid == 0) cout << "C after permutePartition:" << endl; C.show();
    C.broadcastPartition(1,1);
    if (sk_myid == 0) cout << "C after broadcastPartition:" << endl; C.show();
    C.broadcast(4,3);
    if (sk_myid == 0) cout << "C after broadcast:" << endl; C.show();
    DistributedMatrix<int> D = A.mapIndex(sum);
    if (sk_myid == 0) cout << "D:" << endl; D.show(); 
    MPI_Barrier(MPI_COMM_WORLD);
    D.mapInPlace(inc);  
    if (sk_myid == 0) cout << "D after mapInPlace:" << endl; D.show(); 
    MPI_Barrier(MPI_COMM_WORLD);
    D.mapIndexInPlace(sum);  
    if (sk_myid == 0) cout << "D after mapIndexInPlace:" << endl; D.show(); 
    DistributedMatrix<int> E  = A.zipWithIndex(A,& sum4);
    if (sk_myid == 0) cout << "E:" << endl; E.show();
    E.zipWithInPlace(A,add);
    if (sk_myid == 0) cout << "E after zipWithInPlace:" << endl; E.show(); 
    E.zipWithIndexInPlace(A,sum4);
    if (sk_myid == 0) cout << "E after zipWithIndexInPlace:" << endl; E.show(); 

    TerminateSkeletons();}
catch(Exception&){cout << "Exception" << endl << flush;}                 
}
