#include "Skeleton.h"

static int current = 0;

int* init(Empty dummy){if (current++ < 1) return &current;
                       else return NULL;}

bool gth(int x,int y){return x>y;}
bool lth(int x,int y){return x<y;}

void solve(Empty dummy){
  int* valref;
  do{
    valref = get<int>(); // NULL indicates termination
    if (valref != NULL) {
      put<int>((*valref)*2); put<int>((*valref)*2+1);}
  }while (valref != NULL);}

int square(int x){return x * x;}
 
void fin(int n){cout << "Result: "<< n << endl << flush;}

int main(int argc, char **argv){

// *************************************************************
// Test: search skeleton
// ************************************************************* 

  try{
    InitSkeletons(argc,argv);

    // 2-parallel depth first search
    if (sk_myid == 4) cout << "Test 1: 2-parallel depth first search" << endl;
    Initial<int>        p1(init); 
    Filter<int,int>     p2(solve,1);
    Stack<int> st;
    Search<int>         p3(p2,2,st,curry(lth)(20),curry(gth)(35)); 
    Final<int>          p4(& fin);  
    Pipe                p5(p1,p3,p4);
    p5.start();

    // 2-parallel breadth first search
    if (sk_myid == 4) cout << "Test 2: 2-parallel breadth first search" << endl;
    current = 0;
    Initial<int>        p6(init); 
    Filter<int,int>     p7(solve,1);    Queue<int> q;
    Search<int>         p8(p2,2,q,curry(lth)(20),curry(gth)(35)); 
    Final<int>          p9(& fin);  
    Pipe                p10(p6,p8,p9);
    p10.start();

    TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;}
}
