#include "Skeleton.h"

template <class I, class O, class F>
O apply(const Fct1<I,O,F> f, I x){
  return f(x);}

template <class I, class O>
O apply(O (*f)(I), I x){
  return apply(curry(f),x);}

int times(int x, int y){return x*y;}

int dup(int x){return 2*x;}

int add(int x, int y){return x+y;}

template <class C>
C ifThenElse(bool b, C c1, C c2){
    if (b) return c1; else return c2;}

int exor(const int x, const int y){return (x^y);}

int xor1(const int x){return (x^1);}

int sum4(const int a, const int b, const int c, const int d){return a+b+c+d;}

int main(int argc, char **argv){

//**************************************************************
// Test:  test partial applications and C functions as arguments
// *************************************************************
  try{
    InitSkeletons(argc,argv);
     if (sk_myid == 0){
       cout << "apply(& dup,3) = "<< apply(& dup,3) << endl;
       cout << "apply(curry(times)(2),3) = " << apply(curry(times)(2),3) << endl;
       cout << "curry(times)(2)(3) = " << curry(times)(2)(3) << endl;
       cout << "curry(ifThenElse)(true)(2)(3) = " << curry(ifThenElse<int>)(true)(2)(3) << endl;
       cout << "curry(sum4)(1)(2)(3)(4): " << curry(sum4)(1)(2)(3)(4) << endl;
       cout << "curry(sum4)(1)(2)(3): " << curry(sum4)(1)(2)(3) << endl; 
       cout << "curry(sum4)(1)(2): " <<curry(sum4)(1)(2) << endl; 
       cout << "curry(sum4)(1): " <<curry(sum4)(1) << endl; 
       cout << "curry(sum4): " <<curry(sum4) << endl; 
     }

    DistributedArray<int> A(20,& dup);
    A.mapInPlace(dup);
    A.permutePartition(xor1);
    int result1 =  A.map(& dup).fold(add);
    if (sk_myid == 0) cout << "Result 1: " << result1 << endl;

    DistributedArray<int> B(20,curry(times)(2));
    B.mapInPlace(curry(times)(2));
    B.permutePartition(curry(exor)(1));
    int result2 =  B.map(curry(times)(2)).fold(curry(add));
    if (sk_myid == 0) cout << "Result 2: " << result2 << endl;
    TerminateSkeletons();}
  catch(Exception&){cout << "Exception";}
}
