#include "Skeleton.h"

static int current = 0;

int* init(int limit, Empty dummy){
  if (current++ < limit) return &current;
  else return NULL;}

int add(const int a, const int b){return a+b;}

int mapfold(int x){
  DistributedMatrix<int> A(10,10,add,2,2);
  A.mapInPlace(curry(add)(x));
  return A.fold(curry(add));
}

void fin(int n){cout << "result: "<< n << endl << flush;}

int main(int argc, char **argv){
//*************************************************************
// Test 3: test of data and task parallel skeletons
// *************************************************************
// 
  try{
    InitSkeletons(argc,argv);

// step 1: create a process topology (using C++ constructors)
     Initial<int>    p1(curry(init)(5)); 
     Atomic<int,int> p2(& mapfold, 4);  // this uses internal data parallelism  
     Final<int>      p3(& fin); 
     Pipe            p4(p1,p2);
     Pipe            p5(p4,p3);

// step 2: 
// (each processor will pick its part of the computation depending on its rank)
    
    p5.start();

    TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;}
}
