#include "Skeleton.h"

int add(const int a, const int b){return a+b;}

int id(int a) {return a;}

static int current = 0;

int* init(int limit, Empty dummy){
  if (current++ < limit) return &current;
  else return NULL;}

int square(int x){return x * x;}

int mapfold(int x){
  DistributedArray<int> A(20,curry(add)(x));
  A.mapInPlace(curry(add)(1));
  return A.fold(curry(add));
}

void fin(int n){cout << "result: " << n << endl << flush;}

int main(int argc, char **argv){
//*************************************************************
// Test:  sequence of independent skeleton computations
// *************************************************************
  try{
    InitSkeletons(argc,argv);

    //1) purely task parallel computation    
    if (sk_myid == 0) cout << "Test 1: purely task parallel computation" << endl;
    Initial<int>       p1(curry(init)(3)); 
    Atomic<int,int>    p2(square,1);
    Final<int>         p3(& fin);  
    Pipe               p4(p1,p2);
    Pipe               p5(p4,p3);
    p5.start();

    //2) mixed data and task parallel computation
    if (sk_myid == 0) cout << "Test 2: mixed data and task parallel computation" << endl;
    current = 0;
    Initial<int>    p7(curry(init)(3)); 
    Atomic<int,int> p8(& mapfold, 4);  // this uses internal data parallelism  
    Final<int>      p9(& fin); 
    Pipe            p10(p7,p8);
    Pipe            p11(p10,p9);
    p11.start();

   TerminateSkeletons();}
  catch(Exception&){cout << "Exception" << endl << flush;}                 
}
