#include "Skeleton.h"

int add(const int a, const int b){return a+b;}

int id(int a) {return a;}

int xor(int a, int b){return a^b;}


static int current = 0;

int* init(Empty dummy){if (current++ < 5) return &current;
            else return NULL;}

int square(int x){return x * x;}

int mapfold(int x){
  DistributedArray<int,20> A(curry(add)(x));
  A.mapInPlace(curry(add)(1));
  return A.fold(curry(add));
}

void fin(int n){printf("result: %d\n",n); fflush(stdout);}

int main(int argc, char **argv){
//*************************************************************
// Test:  sequence of independent skeleton computations
// *************************************************************
// 
  try{
    InitSkeletons(argc,argv);

// 1) purely data parallel computation
    DistributedArray<int,20> A(curry(id));
    A.mapInPlace(curry(add)(1));
    DistributedArray<int,20> B = A.map(curry(add)(1));  
    B.permute(curry(xor)(1));
    int result =  B.fold(curry(add));
    if (sk_myid == 0) cout << "Result: " << result << endl;

// 2) purely task parallel computation   
    const static int numworkers =2;
    Process*  ps[numworkers];
    for (int i=0; i<numworkers; i++) 
       ps[i] = new Atomic<int,int>(& square,1); 
    Pipe      p1(Initial<int>(init, argc, argv),Farm<int,int>(ps,numworkers));
    Pipe      p2(p1,Final<int>(fin));
    p2.start();

// 3) mixed data and task parallel computation
     Initial<int>    p3(init, argc, argv); 
     Atomic<int,int> p4(mapfold, 4);  // this uses internal data parallelism  
     Final<int>      p5(fin); 
     Pipe            p6(p3,p4);
     Pipe            p7(p6,p5);
     p7.start();

    TerminateSkeletons();}
  catch(Exception){printf("Exception");};                  
}
